import Vue from "vue";

// 缓存
const DicsCatch = {};
// 单级下拉字典项
Vue.prototype.$dicsListsInit = function (selectList) {

    return new Promise((resolve, reject) => {
        let noSelectList = {};
        for (let selectNames in selectList) {
            let dicsName = selectList[selectNames];
            if (!!DicsCatch[dicsName]) {
                this[selectNames] = DicsCatch[dicsName]
            } else {
                noSelectList[selectNames] = dicsName
            }
        }

        if (Object.values(noSelectList).length <= 0) {
            resolve()
        } else {
            this.$axios({
                method: "post",
                url: this.$api.common.getDictListsByTypes,
                data: {
                    dictTypes: Object.values(noSelectList).join(",")
                }
            }).then(res => {
                if (res.code != 200) {
                    this.$message.error(res.message || "字典获取失败");
                    reject();
                    return false;
                }
                let result = res.info;
                for (let selectNames in noSelectList) {
                    let dicsName = noSelectList[selectNames];
                    for (let i = 0; i < result[dicsName].length; i++) {
                        this[selectNames].push({
                            name: result[dicsName][i].dictName,
                            code: result[dicsName][i].dictCode,
                        });
                    }
                    DicsCatch[dicsName] = this[selectNames]
                }
                resolve();
            }).catch(error => {
                this.$message.error("网络异常");
                reject(error);
            });
        }
    });
}



// 缓存
const DicsTreeCatch = {};
// 单级下拉字典项
Vue.prototype.$dicsTreesInit = function (selectList) {

    return new Promise((resolve, reject) => {
        let noSelectList = {};
        for (let selectNames in selectList) {
            let dicsName = selectList[selectNames];
            if (!!DicsTreeCatch[dicsName]) {
                this[selectNames] = DicsTreeCatch[dicsName]
            } else {
                noSelectList[selectNames] = dicsName
            }
        }

        if (Object.values(noSelectList).length <= 0) {
            resolve()
        } else {
            this.$axios({
                method: "post",
                url: this.$api.common.getDictTreesByTypes,
                data: {
                    dictTypes: Object.values(noSelectList).join(",")
                }
            }).then(res => {
                if (res.code != 200) {
                    this.$message.error(res.message || "字典获取失败");
                    reject();
                    return false;
                }
                let result = res.info;
                for (let selectNames in noSelectList) {
                    let dicsName = noSelectList[selectNames];
                    // for (let i = 0; i < result[dicsName].length; i++) {
                    //     this[selectNames].push({
                    //         name: result[dicsName][i].dictName,
                    //         code: result[dicsName][i].dictCode,
                    //     });
                    // }
                    this[selectNames] = result[dicsName]
                    DicsTreeCatch[dicsName] = this[selectNames]
                }
                resolve();
            }).catch(error => {
                this.$message.error("网络异常");
                reject(error);
            });
        }
    });
}